Index: ChangeLog
===================================================================
--- ChangeLog	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ ChangeLog	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -1,4 +1,10 @@
+2004-12-11  Paul Brossier <piem@altern,org>
+	* swig/Makefile.am: instructions moved to python/aubio and cleaned
+	* python/aubiocut: corrected slicing on multichannel files
+	* VERSION: bumped to 0.1.8
+
 2004-12-06  Paul Brossier <piem@altern.org>
 	* examples/{midi*,testforclam}.c: removed
+	* src/{sndfile,midi*,jackio}.[ch]: moved to ext
 
 2004-12-03  Paul Brossier <piem@altern.org>
@@ -17,4 +23,5 @@
 2004-10-28  Paul Brossier <piem@altern.org>
 	* src/Makefile.am: added config.h installation
+	* VERSION: 0.1.7.1
 
 2004-10-26  Paul Brossier <piem@altern.org>:
Index: VERSION
===================================================================
--- VERSION	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ VERSION	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -1,5 +1,5 @@
 AUBIO_MAJOR_VERSION=0
 AUBIO_MINOR_VERSION=1
-AUBIO_PATCH_VERSION=7
-AUBIO_VERSION_STATUS=.2
+AUBIO_PATCH_VERSION=8
+AUBIO_VERSION_STATUS=
 
Index: doc/Makefile.am
===================================================================
--- doc/Makefile.am	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ doc/Makefile.am	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -6,4 +6,5 @@
 
 man_MANS = aubionotes.1 aubioonset.1
+CLEANFILES = $(man_MANS)
 #docbook_docs = aubio-devdoc.xml
 #DOCBOOK_STYLESHEET ?= http://docbook.sourceforge.net/release/xsl/current/html/chunk.xsl
Index: doc/Makefile.in
===================================================================
--- doc/Makefile.in	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ doc/Makefile.in	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -161,4 +161,5 @@
 
 man_MANS = aubionotes.1 aubioonset.1
+CLEANFILES = $(man_MANS)
 subdir = doc
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -297,4 +298,5 @@
 
 clean-generic:
+	-test -z "$(CLEANFILES)" || rm -f $(CLEANFILES)
 
 distclean-generic:
Index: ext/Makefile.am
===================================================================
--- ext/Makefile.am	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ ext/Makefile.am	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -1,4 +1,2 @@
-EXTRA_DIST = aubio_priv.h
-
 pkginclude_HEADERS = aubioext.h \
 	jackio.h \
Index: ext/Makefile.in
===================================================================
--- ext/Makefile.in	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ ext/Makefile.in	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -152,6 +152,4 @@
 sysconfdir = @sysconfdir@
 target_alias = @target_alias@
-EXTRA_DIST = aubio_priv.h
-
 pkginclude_HEADERS = aubioext.h \
 	jackio.h \
Index: plugins/puredata/Makefile.am
===================================================================
--- plugins/puredata/Makefile.am	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ plugins/puredata/Makefile.am	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -9,5 +9,5 @@
 
 ## Make and install the shared library.
-pdinstalldir = $(pddir)/extra/aubio
+pdinstalldir = $(pddir)/extra
 
 # Automake won't accept something ending in ".pd_linux" as a library
@@ -38,4 +38,3 @@
 noinst_SCRIPTS = libtoolkludge
 
-## version.h is there for the Windows platform (no autoconf)
-EXTRA_DIST = $(pdinstall_DATA) $(noinst_SCRIPTS) version.h
+EXTRA_DIST = $(pdinstall_DATA) $(noinst_SCRIPTS)
Index: plugins/puredata/Makefile.in
===================================================================
--- plugins/puredata/Makefile.in	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ plugins/puredata/Makefile.in	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -162,5 +162,5 @@
 
 #SUBDIRS = ladspa vst win
-pdinstalldir = $(pddir)/extra/aubio
+pdinstalldir = $(pddir)/extra
 
 # Automake won't accept something ending in ".pd_linux" as a library
@@ -188,5 +188,5 @@
 noinst_SCRIPTS = libtoolkludge
 
-EXTRA_DIST = $(pdinstall_DATA) $(noinst_SCRIPTS) version.h
+EXTRA_DIST = $(pdinstall_DATA) $(noinst_SCRIPTS)
 subdir = plugins/puredata
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
Index: plugins/puredata/libtoolkludge
===================================================================
--- plugins/puredata/libtoolkludge	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ plugins/puredata/libtoolkludge	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -1,5 +1,11 @@
 #! /bin/sh
 
+# added --mode=link
 if test \( $# -gt 1 \) -a \( $1 = "--mode=link" \); then
+  shift;
+  echo " libtoolkludge running \"$*\""
+  $*
+  exit 0
+elif test \( $# -gt 1 \) -a \( $1 = "--mode=install" \); then
   shift;
   echo " libtoolkludge running \"$*\""
Index: python/aubio/Makefile.am
===================================================================
--- python/aubio/Makefile.am	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ python/aubio/Makefile.am	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -1,10 +1,20 @@
-EXTRA_DIST = __init__.py onsetcompare.py aubioclass.py gnuplot.py\
-	median.py txtfile.py
-
 pkgpython_PYTHON = __init__.py onsetcompare.py\
 	gnuplot.py median.py txtfile.py aubioclass.py
+	
+nodist_pkgpython_PYTHON = aubiowrapper.py _aubiowrapper.so
 
-clean:
-	rm -f *.pyc
+CLEANFILES = *.pyc *.so *.o aubio_wrap.c aubiowrapper.py 
 
-distclean: clean
+all: _aubiowrapper.so
+
+SWIG = swig
+# removed -Wall -Wmissing-prototypes -Wmissing-declarations 
+SWCFLAGS = -DJACK_SUPPORT -Werror -Wno-char-subscripts -Wno-unknown-pragmas -I/usr/include/python2.3 -I../../src -I../../ext -I/usr/include
+SWLDFLAGS = -shared -L../../ext/.libs -laubioext -L../../src/.libs -laubio
+
+aubio_wrap.c:
+	$(SWIG) -outdir . -o aubio_wrap.c -python ../../swig/aubio.i
+
+_aubiowrapper.so: aubio_wrap.c
+	$(CC)   $(SWCFLAGS) -c aubio_wrap.c
+	$(CC)   $(SWLDFLAGS) aubio_wrap.o -o _aubiowrapper.so
Index: python/aubio/Makefile.in
===================================================================
--- python/aubio/Makefile.in	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ python/aubio/Makefile.in	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -152,11 +152,16 @@
 sysconfdir = @sysconfdir@
 target_alias = @target_alias@
-EXTRA_DIST = __init__.py onsetcompare.py aubioclass.py gnuplot.py\
-	median.py txtfile.py
-
-
 pkgpython_PYTHON = __init__.py onsetcompare.py\
 	gnuplot.py median.py txtfile.py aubioclass.py
 
+
+nodist_pkgpython_PYTHON = aubiowrapper.py _aubiowrapper.so
+
+CLEANFILES = *.pyc *.so *.o aubio_wrap.c aubiowrapper.py 
+
+SWIG = swig
+# removed -Wall -Wmissing-prototypes -Wmissing-declarations 
+SWCFLAGS = -DJACK_SUPPORT -Werror -Wno-char-subscripts -Wno-unknown-pragmas -I/usr/include/python2.3 -I../../src -I../../ext -I/usr/include
+SWLDFLAGS = -shared -L../../ext/.libs -laubioext -L../../src/.libs -laubio
 subdir = python/aubio
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -185,4 +190,27 @@
 	-rm -f libtool
 uninstall-info-am:
+nodist_pkgpythonPYTHON_INSTALL = $(INSTALL_DATA)
+install-nodist_pkgpythonPYTHON: $(nodist_pkgpython_PYTHON)
+	@$(NORMAL_INSTALL)
+	$(mkinstalldirs) $(DESTDIR)$(pkgpythondir)
+	@list='$(nodist_pkgpython_PYTHON)'; dlist=''; for p in $$list; do\
+	  if test -f "$$p"; then b=; else b="$(srcdir)/"; fi; \
+	  if test -f $$b$$p; then \
+	    d=`echo "$$p" | sed -e 's,^.*/,,'`; \
+	    dlist="$$dlist $$d"; \
+	    echo " $(nodist_pkgpythonPYTHON_INSTALL) $$b$$p $(DESTDIR)$(pkgpythondir)/$$d"; \
+	    $(nodist_pkgpythonPYTHON_INSTALL) $$b$$p $(DESTDIR)$(pkgpythondir)/$$d; \
+	  else :; fi; \
+	done; \
+	PYTHON=$(PYTHON) $(py_compile) --basedir $(DESTDIR)$(pkgpythondir) $$dlist
+
+uninstall-nodist_pkgpythonPYTHON:
+	@$(NORMAL_UNINSTALL)
+	list='$(nodist_pkgpython_PYTHON)'; for p in $$list; do \
+	  d=`echo "$$p" | sed -e 's,^.*/,,'`; \
+	  rm -f $(DESTDIR)$(pkgpythondir)/$$d; \
+	  rm -f $(DESTDIR)$(pkgpythondir)/$${d}c; \
+	  rm -f $(DESTDIR)$(pkgpythondir)/$${d}o; \
+	done
 pkgpythonPYTHON_INSTALL = $(INSTALL_DATA)
 install-pkgpythonPYTHON: $(pkgpython_PYTHON)
@@ -251,5 +279,5 @@
 
 installdirs:
-	$(mkinstalldirs) $(DESTDIR)$(pkgpythondir)
+	$(mkinstalldirs) $(DESTDIR)$(pkgpythondir) $(DESTDIR)$(pkgpythondir)
 install: install-am
 install-exec: install-exec-am
@@ -269,4 +297,5 @@
 
 clean-generic:
+	-test -z "$(CLEANFILES)" || rm -f $(CLEANFILES)
 
 distclean-generic:
@@ -292,5 +321,5 @@
 info-am:
 
-install-data-am: install-pkgpythonPYTHON
+install-data-am: install-nodist_pkgpythonPYTHON install-pkgpythonPYTHON
 
 install-exec-am:
@@ -318,5 +347,6 @@
 ps-am:
 
-uninstall-am: uninstall-info-am uninstall-pkgpythonPYTHON
+uninstall-am: uninstall-info-am uninstall-nodist_pkgpythonPYTHON \
+	uninstall-pkgpythonPYTHON
 
 .PHONY: all all-am check check-am clean clean-generic clean-libtool \
@@ -324,16 +354,21 @@
 	dvi-am info info-am install install-am install-data \
 	install-data-am install-exec install-exec-am install-info \
-	install-info-am install-man install-pkgpythonPYTHON \
-	install-strip installcheck installcheck-am installdirs \
-	maintainer-clean maintainer-clean-generic mostlyclean \
-	mostlyclean-generic mostlyclean-libtool pdf pdf-am ps ps-am \
-	uninstall uninstall-am uninstall-info-am \
+	install-info-am install-man install-nodist_pkgpythonPYTHON \
+	install-pkgpythonPYTHON install-strip installcheck \
+	installcheck-am installdirs maintainer-clean \
+	maintainer-clean-generic mostlyclean mostlyclean-generic \
+	mostlyclean-libtool pdf pdf-am ps ps-am uninstall uninstall-am \
+	uninstall-info-am uninstall-nodist_pkgpythonPYTHON \
 	uninstall-pkgpythonPYTHON
 
 
-clean:
-	rm -f *.pyc
-
-distclean: clean
+all: _aubiowrapper.so
+
+aubio_wrap.c:
+	$(SWIG) -outdir . -o aubio_wrap.c -python ../../swig/aubio.i
+
+_aubiowrapper.so: aubio_wrap.c
+	$(CC)   $(SWCFLAGS) -c aubio_wrap.c
+	$(CC)   $(SWLDFLAGS) aubio_wrap.o -o _aubiowrapper.so
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
Index: python/aubiocut
===================================================================
--- python/aubiocut	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ python/aubiocut	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -61,5 +61,6 @@
 		    fromcross = 0
 		    while (zerocross < readsize):
-		    	mycopy.set(myvec.get(zerocross,0),fromcross,0)
+		    	for i in range(channels):
+			    	mycopy.set(myvec.get(zerocross,i),fromcross,i)
 			fromcross += 1
 			zerocross += 1
Index: swig/Makefile.am
===================================================================
--- swig/Makefile.am	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ swig/Makefile.am	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -1,25 +1,2 @@
+# see ../python/Makefile.am
 EXTRA_DIST = aubio.i
-
-PYTHON_DIR = ../python/aubio
-SWIG = swig
-#SW_FLAGS = -c++
-# removed -Wall -Wmissing-prototypes -Wmissing-declarations 
-SW_CFLAGS = -DJACK_SUPPORT -shared -Werror -Wno-char-subscripts -Wno-unknown-pragmas
-#SW_CFLAGS = -Wno-missing-prototypes -Wno-missing-declarations
-SWINCLUDE = -I/usr/include/python2.3 -I../src -I../ext -I/usr/include
-SWLDFLAGS = -L../ext/.libs -laubioext -L../src/.libs -laubio
-
-all:
-	$(SWIG) $(SW_FLAGS) -outdir $(PYTHON_DIR) -python aubio.i
-	$(CC) $(SW_CFLAGS) -c aubio_wrap.c $(SWINCLUDE)
-	$(CC) $(SW_CFLAGS) aubio_wrap.o -o $(PYTHON_DIR)/_aubiowrapper.so $(SWLDFLAGS)
-
-install:
-	$(mkinstalldirs) $(DESTDIR)$(pkgpythondir)
-	$(INSTALL) $(PYTHON_DIR)/_aubiowrapper.so $(DESTDIR)$(pkgpythondir)
-	$(INSTALL) -m644 $(PYTHON_DIR)/aubiowrapper.py $(DESTDIR)$(pkgpythondir)
-
-clean:
-	rm -f aubio_wrap.{c,o} $(PYTHON_DIR)/{_aubiowrapper.so,aubiowrapper.py,aubiowrapper.pyc}
-
-distclean: clean
Index: swig/Makefile.in
===================================================================
--- swig/Makefile.in	(revision 205da8624a8b1168910b306610a6f23a78b2ac01)
+++ swig/Makefile.in	(revision 77494e72cb00f6dcf202d762e60795237ba95170)
@@ -152,14 +152,7 @@
 sysconfdir = @sysconfdir@
 target_alias = @target_alias@
+
+# see ../python/Makefile.am
 EXTRA_DIST = aubio.i
-
-PYTHON_DIR = ../python/aubio
-SWIG = swig
-#SW_FLAGS = -c++
-# removed -Wall -Wmissing-prototypes -Wmissing-declarations 
-SW_CFLAGS = -DJACK_SUPPORT -shared -Werror -Wno-char-subscripts -Wno-unknown-pragmas
-#SW_CFLAGS = -Wno-missing-prototypes -Wno-missing-declarations
-SWINCLUDE = -I/usr/include/python2.3 -I../src -I../ext -I/usr/include
-SWLDFLAGS = -L../ext/.libs -laubioext -L../src/.libs -laubio
 subdir = swig
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -230,4 +223,5 @@
 
 installdirs:
+install: install-am
 install-exec: install-exec-am
 install-data: install-data-am
@@ -307,19 +301,4 @@
 	uninstall-info-am
 
-
-all:
-	$(SWIG) $(SW_FLAGS) -outdir $(PYTHON_DIR) -python aubio.i
-	$(CC) $(SW_CFLAGS) -c aubio_wrap.c $(SWINCLUDE)
-	$(CC) $(SW_CFLAGS) aubio_wrap.o -o $(PYTHON_DIR)/_aubiowrapper.so $(SWLDFLAGS)
-
-install:
-	$(mkinstalldirs) $(DESTDIR)$(pkgpythondir)
-	$(INSTALL) $(PYTHON_DIR)/_aubiowrapper.so $(DESTDIR)$(pkgpythondir)
-	$(INSTALL) -m644 $(PYTHON_DIR)/aubiowrapper.py $(DESTDIR)$(pkgpythondir)
-
-clean:
-	rm -f aubio_wrap.{c,o} $(PYTHON_DIR)/{_aubiowrapper.so,aubiowrapper.py,aubiowrapper.pyc}
-
-distclean: clean
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.